<?php 

namespace Management\Services;

use Doctrine\ORM\EntityManager;
use Management\Util;

class BranchProfileService {

    public function __construct(EntityManager $entityManager) {
        $this->entityManager = $entityManager;
    }

	public function getRelatedProfiles($CDOPERADOR,$NRORG, $FILTER) {
		$params = array(
			':CDOPERADOR' => $CDOPERADOR,
			':NRORG' => $NRORG		
		);
		
		$QUERY = "
			SELECT PA.NRPERFILACESSO, PA.NMPERFILACESSO 
				FROM PERFILACESSO PA
				JOIN PERFACESSFILI PF ON
					PF.NRPERFILACESSO = PA.NRPERFILACESSO AND
					PF.NRORG = PA.NRORG
				WHERE PF.CDOPERADOR = :CDOPERADOR
					AND PF.NRORG = :NRORG ";
					if($FILTER != ''){
						$QUERY .= "AND LOWER(PA.NRPERFILACESSO||PA.NMPERFILACESSO) LIKE LOWER('".$FILTER."')";
						
					}
					$QUERY .= "
					GROUP BY PA.NRPERFILACESSO,  PA.NMPERFILACESSO 
					ORDER BY PA.NRPERFILACESSO
					";
			
		return $this->entityManager->getConnection()->fetchAll($QUERY, $params);
	}

	public function getRelatedBranches($NRPERFILACESSO, $CDOPERADOR, $NRORG, $FILTER) {
		$params = array(
			':CDOPERADOR' => $CDOPERADOR,
			':NRPERFILACESSO' => $NRPERFILACESSO,
			':NRORG' => $NRORG		
		);
		
		$GET_RELATED_BRANCH = "
	SELECT FI.CDFILIAL, FI.NMFILIAL, FI.IDSTATUSBLOQ, P.IDBLOCKFILIAL 
		FROM FILIAL FI
		JOIN PERFACESSFILI PF ON
			PF.CDFILIAL = FI.CDFILIAL AND
			PF.NRORG = FI.NRORG
		JOIN PERFILACESSO P ON
			PF.NRPERFILACESSO = P.NRPERFILACESSO
		WHERE PF.CDOPERADOR = :CDOPERADOR
			AND PF.NRORG = :NRORG
			AND PF.NRPERFILACESSO = :NRPERFILACESSO
			AND ( INSTR((
		        SELECT
		            CASE IDBLOCKFILIAL
		                WHEN 'S'   THEN
		                    'N'
		                WHEN 'N'   THEN
		                    'S_N'
		            END AS IDSTATUSBLOQ
		        FROM
		            PERFILACESSO
		        WHERE
		            NRPERFILACESSO = :NRPERFILACESSO
		    ), FI.IDSTATUSBLOQ) <> 0 )";
		    if($FILTER != ''){
		    	$GET_RELATED_BRANCH .= " AND LOWER(FI.CDFILIAL||FI.NMFILIAL) LIKE LOWER('".$FILTER."') ";  
		    }
		    $GET_RELATED_BRANCH .= "
			GROUP BY FI.CDFILIAL,  FI.NMFILIAL, FI.IDSTATUSBLOQ, P.IDBLOCKFILIAL 
			ORDER BY FI.CDFILIAL";
			
			
			
		return $this->entityManager->getConnection()->fetchAll($GET_RELATED_BRANCH, $params);
	}
	
	public function updateProfileAndBranch($CDOPERADOR, $NRORG, $NRPERFILACESSO, $CDFILIAL){
		$params = array(
			':CDOPERADOR' => $CDOPERADOR,
			':NRPERFILACESSO' => $NRPERFILACESSO,
			':CDFILIAL' => $CDFILIAL,
			':NRORG' => $NRORG		
		);
		return $this->entityManager->getConnection()->executeQuery(SELF::UPDATE_PROFILE_BRANCH, $params);
	}
	
	public function setCdPerfilSelecionado($cdperfilselecionado, $cdoperador, $nrorg) {
		if( !empty($cdperfilselecionado) && 
			!empty($cdoperador) &&
			!empty($nrorg)) {
				
			$params = array(
				':CDPERFILSELECIONADO' => $cdperfilselecionado,
				':NRORG'	 => $nrorg,
				':CDOPERADOR'	 => $cdoperador,
			);
			$this->entityManager->getConnection()->executeQuery(self::UPDATE_PERFIL_SELECIONADO, $params);
		} else 
			throw new \Exception("Não foi possível alterar a unidade e o perfil deste operador !");
	}
	
	public function getIsAdministrator($CDOPERADOR, $NRORG, $NRPERFILACESSO, $CDFILIAL){
		$params = array(
			':CDOPERADOR'     => $CDOPERADOR,
			':NRPERFILACESSO' => $NRPERFILACESSO,
			':CDFILIAL'       => $CDFILIAL,
			':NRORG'          => $NRORG		
		);
		$retorno = $this->entityManager->getConnection()->fetchAll(SELF::GET_IS_ADMINISTRATOR, $params);;
		
		if(!empty($retorno)){
		  $retorno = $retorno[0]['IDPERFILACESSOADM'];
		}else{
		  $retorno = 'N';
		}
		
		if($retorno == 'S') {
			return true;
		} else {
			return false;
		}
	}
	
	const GET_IS_ADMINISTRATOR = "
		SELECT IDPERFILACESSOADM FROM PERFILACESSO WHERE NRORG = :NRORG AND NRPERFILACESSO = :NRPERFILACESSO
	";
	
	const UPDATE_PERFIL_SELECIONADO = "
		UPDATE OPERADOR 
		SET CDPERFILSELECIONADO = :CDPERFILSELECIONADO
		WHERE CDOPERADOR = :CDOPERADOR
		AND NRORG = :NRORG
	";

	const UPDATE_PROFILE_BRANCH = "
	UPDATE OPERADOR SET
		CDFILIALSELECIONADA = :CDFILIAL,
		CDPERFILSELECIONADO = :NRPERFILACESSO
		WHERE CDOPERADOR = :CDOPERADOR
		AND NRORG = :NRORG";
} 